# Interface FunctionCalculatorImpl.Functions

Enclosing class:
  `FunctionCalculatorImpl`

protected static interface FunctionCalculatorImpl.Functions
Function implementations.

Version:
  1.16.0
Author:
  Mikko Tommila

- ## Method Summary

  Modifier and Type
  Method
  Description
  `Number`
  `abs(Number x)`
  `Number`
  `acos(Number x)`
  `Number`
  `acosh(Number x)`
  `Number`
  `add(Number x, Number y)`
  `Number`
  `agm(Number x, Number y)`
  `Number`
  `airyAi(Number x)`
  `Number`
  `airyAiPrime(Number x)`
  `Number`
  `airyBi(Number x)`
  `Number`
  `airyBiPrime(Number x)`
  `Number`
  `angerJ(Number x, Number y)`
  `Number`
  `arg(Number x)`
  `Number`
  `asin(Number x)`
  `Number`
  `asinh(Number x)`
  `Number`
  `atan(Number x)`
  `Number`
  `atan2(Number x, Number y)`
  `Number`
  `atanh(Number x)`
  `Number`
  `barnesG(Number x)`
  `Number`
  `bernoulli(Number x)`
  `Number`
  `bernoulliB(Number x, Number y)`
  `Number`
  `besselI(Number x, Number y)`
  `Number`
  `besselJ(Number x, Number y)`
  `Number`
  `besselK(Number x, Number y)`
  `Number`
  `besselY(Number x, Number y)`
  `Number`
  `beta(Number a, Number b)`
  `Number`
  `beta(Number x, Number a, Number b)`
  `Number`
  `beta(Number x1, Number x2, Number a, Number b)`
  `Number`
  `binomial(Number x, Number y)`
  `Number`
  `catalan(Number x)`
  `Number`
  `cbrt(Number x)`
  `Number`
  `ceil(Number x)`
  `Number`
  `chebyshevT(Number x, Number y)`
  `Number`
  `chebyshevU(Number x, Number y)`
  `Number`
  `clausenC(Number x, Number y)`
  `Number`
  `clausenCl(Number x, Number y)`
  `Number`
  `clausenS(Number x, Number y)`
  `Number`
  `clausenSl(Number x, Number y)`
  `Number`
  `conj(Number x)`
  `Number`
  `copySign(Number x, Number y)`
  `Number`
  `cos(Number x)`
  `Number`
  `cosh(Number x)`
  `Number`
  `coshIntegral(Number x)`
  `Number`
  `cosIntegral(Number x)`
  `Number`
  `dawsonF(Number x)`
  `Number`
  `digamma(Number x)`
  `Number`
  `divide(Number x, Number y)`
  `Number`
  `doubleFactorial(Number x)`
  `Number`
  `e(Number x)`
  `Number`
  `ellipticE(Number x)`
  `Number`
  `ellipticK(Number x)`
  `Number`
  `erf(Number x)`
  `Number`
  `erfc(Number x)`
  `Number`
  `erfi(Number x)`
  `Number`
  `euler(Number x)`
  `Number`
  `eulerE(Number x, Number y)`
  `Number`
  `exp(Number x)`
  `Number`
  `expIntegralE(Number x, Number y)`
  `Number`
  `expIntegralEi(Number x)`
  `Number`
  `factorial(Number x)`
  `Number`
  `fibonacci(Number x, Number y)`
  `Number`
  `floor(Number x)`
  `Number`
  `fmod(Number x, Number y)`
  `Number`
  `frac(Number x)`
  `Number`
  `fresnelC(Number x)`
  `Number`
  `fresnelS(Number x)`
  `Number`
  `gamma(Number x)`
  `Number`
  `gamma(Number x, Number y)`
  `Number`
  `gamma(Number x, Number y, Number z)`
  `Number`
  `gcd(Number x, Number y)`
  `Number`
  `gegenbauerC(Number x, Number y)`
  `Number`
  `gegenbauerC(Number x, Number y, Number z)`
  `Number`
  `glaisher(Number x)`
  `Number`
  `harmonicNumber(Number x)`
  `Number`
  `harmonicNumber(Number x, Number y)`
  `Number`
  `hermiteH(Number x, Number y)`
  `Number`
  `hypergeometric0F1(Number a, Number z)`
  `Number`
  `hypergeometric0F1Regularized(Number a, Number z)`
  `Number`
  `hypergeometric1F1(Number a, Number b, Number z)`
  `Number`
  `hypergeometric1F1Regularized(Number a, Number b, Number z)`
  `Number`
  `hypergeometric2F1(Number a, Number b, Number c, Number z)`
  `Number`
  `hypergeometric2F1Regularized(Number a, Number b, Number c, Number z)`
  `Number`
  `hypergeometricU(Number a, Number b, Number z)`
  `Number`
  `hypot(Number x, Number y)`
  `Number`
  `imag(Number x)`
  `Number`
  `inverseErf(Number x)`
  `Number`
  `inverseErfc(Number x)`
  `Number`
  `inverseRoot(Number x, Number y)`
  `Number`
  `inverseRoot(Number x, Number y, Number z)`
  `Number`
  `jacobiP(Number x, Number y, Number z, Number w)`
  `Number`
  `khinchin(Number x)`
  `Number`
  `laguerreL(Number x, Number y)`
  `Number`
  `laguerreL(Number x, Number y, Number z)`
  `Number`
  `lcm(Number x, Number y)`
  `Number`
  `legendreP(Number x, Number y)`
  `Number`
  `legendreP(Number x, Number y, Number z)`
  `Number`
  `legendreQ(Number x, Number y)`
  `Number`
  `legendreQ(Number x, Number y, Number z)`
  `Number`
  `log(Number x)`
  `Number`
  `log(Number x, Number y)`
  `Number`
  `logBarnesG(Number x)`
  `Number`
  `logGamma(Number x)`
  `Number`
  `logIntegral(Number x)`
  `Number`
  `logisticSigmoid(Number x)`
  `Number`
  `max(Number x, Number y)`
  `Number`
  `min(Number x, Number y)`
  `Number`
  `mod(Number x, Number y)`
  `Number`
  `multiply(Number x, Number y)`
  `Number`
  `negate(Number x)`
  `Number`
  `nextAfter(Number x, Number y)`
  `Number`
  `nextDown(Number x)`
  `Number`
  `nextUp(Number x)`
  `Number`
  `pi(Number x)`
  `Number`
  `pochhammer(Number x, Number y)`
  `Number`
  `polygamma(Number x, Number y)`
  `Number`
  `polylog(Number x, Number y)`
  `Number`
  `pow(Number x, Number y)`
  `Number`
  `precision(Number x, Number y)`
  `Number`
  `random(Number x)`
  `Number`
  `randomGaussian(Number x)`
  `Number`
  `real(Number x)`
  `Number`
  `root(Number x, Number y)`
  `Number`
  `root(Number x, Number y, Number z)`
  `Number`
  `round(Number x, Number y)`
  Deprecated.
  `Number`
  `roundToInteger(Number x)`
  `Number`
  `roundToMultiple(Number x, Number y)`
  `Number`
  `roundToPlaces(Number x, Number y)`
  `Number`
  `roundToPrecision(Number x, Number y)`
  `Number`
  `scale(Number x, Number y)`
  `Number`
  `sin(Number x)`
  `Number`
  `sinc(Number x)`
  `Number`
  `sinh(Number x)`
  `Number`
  `sinhIntegral(Number x)`
  `Number`
  `sinIntegral(Number x)`
  `Number`
  `sphericalHarmonicY(Number x, Number y, Number z, Number w)`
  `Number`
  `sqrt(Number x)`
  `Number`
  `stirlingS1(Number x, Number y)`
  `Number`
  `stirlingS2(Number x, Number y)`
  `Number`
  `struveH(Number x, Number y)`
  `Number`
  `struveL(Number x, Number y)`
  `Number`
  `subtract(Number x, Number y)`
  `Number`
  `tan(Number x)`
  `Number`
  `tanh(Number x)`
  `Number`
  `toDegrees(Number x)`
  `Number`
  `toRadians(Number x)`
  `Number`
  `truncate(Number x)`
  `Number`
  `ulp(Number x)`
  `Number`
  `w(Number x)`
  `Number`
  `w(Number x, Number y)`
  `Number`
  `weberE(Number x, Number y)`
  `Number`
  `zeta(Number x)`
  `Number`
  `zeta(Number x, Number y)`

- ## Method Details

  - ### negate

    Number negate(Number x)

  - ### add

    Number add(Number x, Number y)

  - ### subtract

    Number subtract(Number x, Number y)

  - ### multiply

    Number multiply(Number x, Number y)

  - ### divide

    Number divide(Number x, Number y)

  - ### mod

    Number mod(Number x, Number y)

  - ### pow

    Number pow(Number x, Number y)

  - ### arg

    Number arg(Number x)

  - ### conj

    Number conj(Number x)

  - ### imag

    Number imag(Number x)

  - ### real

    Number real(Number x)

  - ### abs

    Number abs(Number x)

  - ### acos

    Number acos(Number x)

  - ### acosh

    Number acosh(Number x)

  - ### airyAi

    Number airyAi(Number x)

  - ### airyAiPrime

    Number airyAiPrime(Number x)

  - ### airyBi

    Number airyBi(Number x)

  - ### airyBiPrime

    Number airyBiPrime(Number x)

  - ### angerJ

    Number angerJ(Number x, Number y)

  - ### asin

    Number asin(Number x)

  - ### asinh

    Number asinh(Number x)

  - ### atan

    Number atan(Number x)

  - ### atanh

    Number atanh(Number x)

  - ### barnesG

    Number barnesG(Number x)

  - ### bernoulli

    Number bernoulli(Number x)

  - ### bernoulliB

    Number bernoulliB(Number x, Number y)

  - ### besselI

    Number besselI(Number x, Number y)

  - ### besselJ

    Number besselJ(Number x, Number y)

  - ### besselK

    Number besselK(Number x, Number y)

  - ### besselY

    Number besselY(Number x, Number y)

  - ### beta

    Number beta(Number a, Number b)

  - ### beta

    Number beta(Number x, Number a, Number b)

  - ### beta

    Number beta(Number x1, Number x2, Number a, Number b)

  - ### binomial

    Number binomial(Number x, Number y)

  - ### catalan

    Number catalan(Number x)

  - ### cbrt

    Number cbrt(Number x)

  - ### ceil

    Number ceil(Number x)

  - ### chebyshevT

    Number chebyshevT(Number x, Number y)

  - ### chebyshevU

    Number chebyshevU(Number x, Number y)

  - ### clausenC

    Number clausenC(Number x, Number y)

  - ### clausenCl

    Number clausenCl(Number x, Number y)

  - ### clausenS

    Number clausenS(Number x, Number y)

  - ### clausenSl

    Number clausenSl(Number x, Number y)

  - ### cos

    Number cos(Number x)

  - ### cosIntegral

    Number cosIntegral(Number x)

  - ### cosh

    Number cosh(Number x)

  - ### coshIntegral

    Number coshIntegral(Number x)

  - ### dawsonF

    Number dawsonF(Number x)

  - ### digamma

    Number digamma(Number x)

  - ### doubleFactorial

    Number doubleFactorial(Number x)

  - ### e

    Number e(Number x)

  - ### ellipticE

    Number ellipticE(Number x)

  - ### ellipticK

    Number ellipticK(Number x)

  - ### erf

    Number erf(Number x)

  - ### erfc

    Number erfc(Number x)

  - ### erfi

    Number erfi(Number x)

  - ### euler

    Number euler(Number x)

  - ### eulerE

    Number eulerE(Number x, Number y)

  - ### exp

    Number exp(Number x)

  - ### expIntegralE

    Number expIntegralE(Number x, Number y)

  - ### expIntegralEi

    Number expIntegralEi(Number x)

  - ### factorial

    Number factorial(Number x)

  - ### fibonacci

    Number fibonacci(Number x, Number y)

  - ### floor

    Number floor(Number x)

  - ### frac

    Number frac(Number x)

  - ### fresnelC

    Number fresnelC(Number x)

  - ### fresnelS

    Number fresnelS(Number x)

  - ### gamma

    Number gamma(Number x)

  - ### gamma

    Number gamma(Number x, Number y)

  - ### gamma

    Number gamma(Number x, Number y, Number z)

  - ### gegenbauerC

    Number gegenbauerC(Number x, Number y)

  - ### gegenbauerC

    Number gegenbauerC(Number x, Number y, Number z)

  - ### harmonicNumber

    Number harmonicNumber(Number x)

  - ### harmonicNumber

    Number harmonicNumber(Number x, Number y)

  - ### hermiteH

    Number hermiteH(Number x, Number y)

  - ### hypergeometric0F1

    Number hypergeometric0F1(Number a, Number z)

  - ### hypergeometric0F1Regularized

    Number hypergeometric0F1Regularized(Number a, Number z)

  - ### hypergeometric1F1

    Number hypergeometric1F1(Number a, Number b, Number z)

  - ### hypergeometric1F1Regularized

    Number hypergeometric1F1Regularized(Number a, Number b, Number z)

  - ### hypergeometric2F1

    Number hypergeometric2F1(Number a, Number b, Number c, Number z)

  - ### hypergeometric2F1Regularized

    Number hypergeometric2F1Regularized(Number a, Number b, Number c, Number z)

  - ### hypergeometricU

    Number hypergeometricU(Number a, Number b, Number z)

  - ### inverseErf

    Number inverseErf(Number x)

  - ### inverseErfc

    Number inverseErfc(Number x)

  - ### jacobiP

    Number jacobiP(Number x, Number y, Number z, Number w)

  - ### glaisher

    Number glaisher(Number x)

  - ### khinchin

    Number khinchin(Number x)

  - ### laguerreL

    Number laguerreL(Number x, Number y)

  - ### laguerreL

    Number laguerreL(Number x, Number y, Number z)

  - ### legendreP

    Number legendreP(Number x, Number y)

  - ### legendreP

    Number legendreP(Number x, Number y, Number z)

  - ### legendreQ

    Number legendreQ(Number x, Number y)

  - ### legendreQ

    Number legendreQ(Number x, Number y, Number z)

  - ### log

    Number log(Number x)

  - ### log

    Number log(Number x, Number y)

  - ### logBarnesG

    Number logBarnesG(Number x)

  - ### logGamma

    Number logGamma(Number x)

  - ### logIntegral

    Number logIntegral(Number x)

  - ### logisticSigmoid

    Number logisticSigmoid(Number x)

  - ### max

    Number max(Number x, Number y)

  - ### min

    Number min(Number x, Number y)

  - ### nextAfter

    Number nextAfter(Number x, Number y)

  - ### nextDown

    Number nextDown(Number x)

  - ### nextUp

    Number nextUp(Number x)

  - ### pi

    Number pi(Number x)

  - ### pochhammer

    Number pochhammer(Number x, Number y)

  - ### polygamma

    Number polygamma(Number x, Number y)

  - ### polylog

    Number polylog(Number x, Number y)

  - ### random

    Number random(Number x)

  - ### randomGaussian

    Number randomGaussian(Number x)

  - ### round

    @Deprecated Number round(Number x, Number y)
    Deprecated.

  - ### roundToPrecision

    Number roundToPrecision(Number x, Number y)

  - ### roundToInteger

    Number roundToInteger(Number x)

  - ### roundToPlaces

    Number roundToPlaces(Number x, Number y)

  - ### roundToMultiple

    Number roundToMultiple(Number x, Number y)

  - ### sin

    Number sin(Number x)

  - ### sinc

    Number sinc(Number x)

  - ### sinIntegral

    Number sinIntegral(Number x)

  - ### sinh

    Number sinh(Number x)

  - ### sinhIntegral

    Number sinhIntegral(Number x)

  - ### sphericalHarmonicY

    Number sphericalHarmonicY(Number x, Number y, Number z, Number w)

  - ### sqrt

    Number sqrt(Number x)

  - ### stirlingS1

    Number stirlingS1(Number x, Number y)

  - ### stirlingS2

    Number stirlingS2(Number x, Number y)

  - ### struveH

    Number struveH(Number x, Number y)

  - ### struveL

    Number struveL(Number x, Number y)

  - ### tan

    Number tan(Number x)

  - ### tanh

    Number tanh(Number x)

  - ### truncate

    Number truncate(Number x)

  - ### toDegrees

    Number toDegrees(Number x)

  - ### toRadians

    Number toRadians(Number x)

  - ### ulp

    Number ulp(Number x)

  - ### weberE

    Number weberE(Number x, Number y)

  - ### zeta

    Number zeta(Number x)

  - ### zeta

    Number zeta(Number x, Number y)

  - ### agm

    Number agm(Number x, Number y)

  - ### w

    Number w(Number x)

  - ### w

    Number w(Number x, Number y)

  - ### atan2

    Number atan2(Number x, Number y)

  - ### copySign

    Number copySign(Number x, Number y)

  - ### fmod

    Number fmod(Number x, Number y)

  - ### gcd

    Number gcd(Number x, Number y)

  - ### hypot

    Number hypot(Number x, Number y)

  - ### inverseRoot

    Number inverseRoot(Number x, Number y)

  - ### inverseRoot

    Number inverseRoot(Number x, Number y, Number z)

  - ### lcm

    Number lcm(Number x, Number y)

  - ### root

    Number root(Number x, Number y)

  - ### root

    Number root(Number x, Number y, Number z)

  - ### scale

    Number scale(Number x, Number y)

  - ### precision

    Number precision(Number x, Number y)